/*
 *  Copyright 1999-2019 Seata.io Group.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package io.seata.saga.statelang.parser.impl;

import io.seata.saga.statelang.domain.CompensationTriggerState;
import io.seata.saga.statelang.domain.impl.CompensationTriggerStateImpl;
import io.seata.saga.statelang.parser.StateParser;

/**
 * 'trigger compensation process' state parser
 *
 * @author lorne.cl
 */
public class CompensationTriggerStateParser extends BaseStatePaser implements StateParser<CompensationTriggerState> {

    @Override
    public CompensationTriggerState parse(Object node) {

        CompensationTriggerStateImpl compensationTriggerState = new CompensationTriggerStateImpl();
        parseBaseAttributes(compensationTriggerState, node);

        return compensationTriggerState;
    }
}